/*
 Copyright (C) 2002 Tommi A. Junttila
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License version 2
 as published by the Free Software Foundation.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef GATEHASH_HH
#define GATEHASH_HH

class GateHash;

#include "defs.hh"
#include "gate.hh"

class GateHash {
  class Entry {
  public:
    Gate *gate;
    Entry *next, *prev;
    Entry(Gate *g, Entry *n, Entry *p);
  };
  int nof_rows;
  Entry **rows;
public:
  GateHash(int);
  ~GateHash();
  Gate *test_and_set(Gate *);
  bool is_in(Gate *gate);
};

#endif
