%{
#include <string.h>
#include "gate.hh"
#include "parser.tab.h"
int cplineno = 1;
extern void cperror2(const char *, ...);
%}
%option noyywrap
%option nounput

%%
[ \t]		;
"//".*\n	cplineno++;
\n		cplineno++;
"ASSIGN"	return(ASSIGN);
"EQUIV"		return(EQUIVf);
"=="		return(EQUIV);
"IMPLY"		return(IMPLYf);
"=>"            return(IMPLY);
"ITE"		return(ITEf);
"OR"		return(ORf);
"|"		return(OR);
"AND"		return(ANDf);
"&"		return(AND);
"EVEN"		return(EVENf);
"ODD"		return(ODDf);
"^"		return(ODD);
"NOT"		return(NOTf);
"~"		return(NOT);
"("		return(LPAREN);
")"		return(RPAREN);
"["		return(LBRACKET);
"]"		return(RBRACKET);
";"		return(SEMICOLON);
","		return(COMMA);
":="		return(DEF);
"T"		return(TRUE);
"F"		return(FALSE);
[a-zA-Z_][a-zA-Z0-9_\']*	{cplval.charptr = strdup(cptext); return(ID); }
\"[^\"]+\"	{cplval.charptr = strdup(cptext); return(ID); }
[1-9][0-9]*	{cplval.intval = atoi(cptext); return(NUM); }
0		{cplval.intval = 0; return(NUM); }
.		cperror2("illegal character '%c'", cptext[0]);
%%

